<template>
  <GManageTable
    :card="card"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value[itemKey]"
    :get-new-item="getNewItem"
    use-wrapper
    :optional="optional"
    :wiki-entry="wikiEntry"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item, updateAvailableElements }">
      <!-- TODO: Remove dumb workaround when i can figure out, why this component is loaded so weirdly. Maybe because of the nested slots of GManageTable? -->
      <component
        :is="StatementMetaData"
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
        :card="false"
      />
    </template>
    <template #[`item.description`]="{ item }">
      <div v-if="item.description && item.description.name">
        {{ getForCurrentLocale(item.description.name) }}
      </div>
      <div
        v-else-if="item.description && item.description.content"
        class="text-truncate default-max-width"
      >
        {{ getForCurrentLocale(item.description) }}
      </div>

      <div v-else>-</div>
    </template>
    <template #[`item.declaration`]="{ item }">
      <div v-if="item.declaration && item.declaration.name">
        {{ getForCurrentLocale(item.declaration.name) }}
      </div>
      <div
        v-else-if="item.declaration && item.declaration.content"
        class="text-truncate default-max-width"
      >
        {{ getForCurrentLocale(item.declaration) }}
      </div>

      <div v-else>-</div>
    </template>
  </GManageTable>
</template>

<script>
import { StatementMetaDataType } from "@d-ptb/dcc-js";
import { removeFromArray } from "assets/util/general";
import { validatableMixin } from "../../Mixins/validatableMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import StatementMetaData from "~/components/DCC/Common/StatementMetaData";

export default {
  name: "StatementList",
  components: {
    GManageTable,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.common.statementListType",
    },
    itemKey: {
      type: String,
      default: "statement",
    },
    card: {
      type: Boolean,
      default: true,
    },
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "statement",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.richContentType.description.title"),
          value: "description",
        },
        {
          text: this.$t("dcc.common.richContentType.declaration.title"),
          value: "declaration",
        },
      ],
      StatementMetaData,
    };
  },
  computed: {
    customRules() {
      return [
        () =>
          this.value[this.itemKey].length > 0 ||
          this.$t(`${this.i18nBase}.empty`),
      ];
    },
  },
  watch: {
    value: {
      deep: true,
      handler() {
        this.validate();
      },
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value[this.itemKey], item);
    },
    create(item) {
      this.value[this.itemKey].push(new StatementMetaDataType(item));
    },
    edit(item, index) {
      this.$set(this.value[this.itemKey], index, undefined);
      this.$set(this.value[this.itemKey], index, item);
    },
    getNewItem() {
      return new StatementMetaDataType();
    },
  },
};
</script>
